# Преимущества Picodata

Продукт Picodata предоставляет платформу для "быстрых" данных и позволяет развернуть распределенный кластер СУБД без лишних затрат времени. Picodata — это надежность и удобство при поддержании работы кластера: удалении и добавлении инстансов, обеспечении отказоустойчивости и прочих процессах, характерных для высоконагруженных систем. Помимо этого, наш продукт обладает следующими достоинствами:

## Гарантия сохранности данных {: #guaranteed_data_security }

Picodata реализует [ACID-подход](https://ru.wikipedia.org/wiki/ACID), при котором любые изменения данных предварительно сохраняются в журнале на диске и реплицируются на несколько серверов. При выходе из строя любого компонента данные автоматически восстанавливаются из существующих копий, что позволяет добиться высокой отказоустойчивости. Все операции с топологией кластера и схемой данных также атомарны.

## Горизонтальное масштабирование {: #horizontal_scaling }

Picodata обеспечивает эффективное управление распределенным кластером. Данные в кластере разделены на независимые фрагменты (шарды) по числу доступных ядер процессора. Такой подход снижает издержки на разделяемый доступ к данным, повышает эффективность использования оборудования и позволяет в любой момент нарастить вычислительную мощность системы.

## Выполнение бизнес-логики внутри решетки данных {: #data_grid }

Picodata предлагает масштабировать не только данные, но и вычисления: система хранит и версионирует программный код на каждом узле кластера. Специалисты компании Picodata разработали целый ряд техник, позволяющих безопасно обновлять распределенные приложения, сохраняя целостность данных и избегая простоев системы (no downtime). Все это позволяет обеспечить очень высокую скорость операций с данными.

## Продукт с открытым исходным кодом {: #open_source }

Picodata — продукт [с открытым кодом](https://git.picodata.io/core/picodata) (open source). Это снижает порог входа в технологию и позволяет познакомиться с разработанным нами решением широкому кругу пользователей.

## Полностью российское программное обеспечение {: #russian_software }

СУБД Picodata создана российскими разработчиками и входит в Реестр отечественного программного обеспечения. Вся поддержка и экспертиза по внедрению доступна в России и на русском языке;

## Сопровождение клиентов и дополнительные услуги {: #client_assistance }

Picodata — это не только программное обеспечение, но и возможность приобрести обслуживание "под ключ", которое будет включать в себя необходимый уровень поддержки. Picodata предоставляет услугу DBA as a Service, что подразумевает администрирование высоконагруженных критичных систем по вашему обращению.
Типовые задачи, решаемые в рамках услуги:

* Резервное копирование и восстановление;
* Проактивный мониторинг доступности;
* Регламентные работы;
* Восстановление узлов кластера после сбоя;
* Заведение пользователей, предоставление прав доступа;
* Управление ресурсами;
* Мониторинг состояния кластера, выявление и устранение проблем;
* Работы по обновлению компонентов ПО кластера;
* Выполнение запросов на изменение настроек кластера.
