# ALTER PLUGIN

[DDL](ddl.md)-команда `ALTER PLUGIN` используется для изменения
конфигурации [плагина](../../overview/glossary.md#plugin).

## Синтаксис {: #syntax }

![ALTER PLUGIN](../../images/ebnf/alter_plugin.svg)

## Параметры {: #params }

* **ENABLE** — включение плагина.
* **DISABLE** — отключение плагина.
* **ADD SERVICE TO TIER** — добавление сервиса плагина к [тиру][tier].
* **REMOVE SERVICE FROM TIER** — удаление сервиса плагина из [тира][tier].
* **SET** — установка значения отдельных параметров сервиса в формате `<service_name.property_key> = ‘<value>’`.
* **MIGRATE TO** — объявление версии плагина и запуск [миграции]. Версия плагина указывается в формате semver.
* **TIMEOUT** — интервал времени, за который Picodata пытается выполнить
  скрипт миграций в кластере. Указанное здесь значение менее
  приоритетно, чем таймауты, заданные для отдельных команд внутри
  скрипта миграции. По этой причине мы не рекомендуем использовать явные
  таймауты в скриптах миграции (т.к. потом их нельзя уже
  переопределить). Если явных таймаутов нет и при этом времени, указанного в команде миграции, не
  хватило, то миграция завершится ошибкой и произойдет ее автоматический откат.
* **ROLLBACK_TIMEOUT** — интервал времени, за который Picodata пытается
  выполнить откат миграции. Помимо недостаточного общего таймаута
  миграции, причиной отката может служить ошибка хотя бы одной команды
  из скрипта миграции. Откат запускается автоматичеси непосредственно
  после ошибки миграции.

[tier]: ../../overview/glossary.md#tier
[миграции]: ../../overview/glossary.md#migration

## Примеры {: #examples }

```sql title="Запуск миграции"
ALTER PLUGIN weather_cache MIGRATE TO 0.1.0;
```

```sql title="Изменение параметра"
ALTER PLUGIN weather_cache 0.1.0 SET weather_service.openweather_timeout='7';
```
