# CREATE PLUGIN

[DDL](ddl.md)-команда `CREATE PLUGIN` используется для регистрации
[плагина](../../overview/glossary.md#plugin) в кластере.

## Синтаксис {: #syntax }

![CREATE PLUGIN](../../images/ebnf/create_plugin.svg)

## Параметры {: #params }

* **PLUGIN** — имя плагина. Соответствует правилам имен для всех
  [объектов](object.md) в кластере. Версия плагина указывается в формате
  semver
* **IF NOT EXISTS** — позволяет избежать ошибки в случае, если такой
  плагин в кластере уже есть
* **TIMEOUT** — интервал времени, за который Picodata пытается создать
  плагин в кластере. Если времени не хватило и вернулась ошибка, то или
  плагин не успел создаться, или создался, но нам не хватило времени
  получить об этом подтверждение. Чтобы проверить статус плагина, можно
  повторить еще раз команду его создания. Если плагин создан, то в
  результате вернется нуль строк. Если же плагин не был создан, то
  вернется одна строка.

## Примеры {: #examples }

```sql
CREATE PLUGIN weather_cache 0.1.0;
```
