# DROP INDEX

[DDL](ddl.md)-команда `DROP INDEX` используется для удаления индекса.

## Синтаксис {: #syntax }

![DROP INDEX](../../images/ebnf/drop_index.svg)

## Параметры {: #params }

* **INDEX** — имя индекса; соответствует правилам имен для всех
[объектов](object.md) в кластере
* **IF EXISTS** — позволяет избежать ошибки в случае, если такого
  индекса в кластере нет
* **WAIT APPLIED** — при использовании этого параметра контроль
  пользователю будет возвращен только после того как данная операция
  будет применена либо во всем кластере (`GLOBALLY`), либо в рамках
  текущего инстанса (`LOCALLY`)
* **TIMEOUT** — интервал времени, за который Picodata пытается удалить
  индекс. Если времени не хватило и вернулась ошибка, то или
  индекс не успел удалиться, или удалился, но нам не хватило времени
  получить об этом подтверждение. Чтобы проверить статус индекса, можно
  повторить еще раз команду его удаления. Если индекс удален, то в
  результате вернется нуль строк. Если же индекс не был удален, то
  вернется одна строка.

## Примеры {: #examples }

```sql
DROP INDEX name_year
OPTION (TIMEOUT = 3.0);
```

```sql
DROP INDEX name_year
WAIT APPLIED GLOBALLY
OPTION (TIMEOUT = 3.0);
```

