# DROP PLUGIN

[DCL](dcl.md)-команда `DROP PLUGIN` используется для удаления существующего
[плагина](../../overview/glossary.md#plugin) из кластера.

## Синтаксис {: #syntax }

![DROP PLUGIN](../../images/ebnf/drop_plugin.svg)

## Параметры {: #params }

* **PLUGIN** — имя роли. Соответствует правилам имен для всех
  [объектов](object.md) в кластере
* **IF EXISTS** — позволяет избежать ошибки в случае, если такого
  плагина в кластере нет
* **WITH DATA** — удаление плагина вместе с его данными (записи в
  системных таблицах плюс выполнение команд из раздела `pico.DOWN` файла
  [миграций])
* **TIMEOUT** — интервал времени, за который Picodata пытается удалить
  плагин в кластере. Если времени не хватило и вернулась ошибка, то или
  плагин не успел удалиться, или удалился, но нам не хватило времени
  получить об этом подтверждение. Чтобы проверить статус плагина, можно
  повторить еще раз команду его удаления. Если плагин удален, то в
  результате вернется нуль строк. Если же плагин не был удален, то
  вернется одна строка.

[миграций]: ../../overview/glossary.md#migration

## Примеры {: #examples }

```sql
DROP PLUGIN weather_cache 0.1.0 WITH_DATA;
```
