# LOCALTIMESTAMP

Функция `LOCALTIMESTAMP` возвращает текущую дату и время в часовом поясе
из текущей сессии SQL. Это возвратит значение `TIMESTAMP`.

В качестве аргумента для функции можно указать целое число от `0` до `6`,
определяющее точность времени. Значения выше `6` игнорируются.

## Синтаксис {: #syntax }

![LOCALTIMESTAMP](../../images/ebnf/localtimestamp.svg)

## Примеры {: #examples }

```sql title="Получение текущей даты и времени"
sql> SELECT localtimestamp;
+-----------------------------+
| col_1                       |
+=============================+
| 2025-02-21T17:47:21.236402Z |
+-----------------------------+
(1 rows)
```

```sql title="Получение текущей даты и времени с повышенной точностью"

sql> select localtimestamp(3);
+--------------------------+
| col_1                    |
+==========================+
| 2025-02-21T17:48:09.981Z |
+--------------------------+
(1 rows)
```

```sql title="Получение текущей даты и времени с максимальной точностью"
sql> SELECT localtimestamp(6);
+-----------------------------+
| col_1                       |
+=============================+
| 2025-02-21T17:51:18.664697Z |
+-----------------------------+
(1 rows)
```
